{$A+,B-,C+,D+,E-,F-,G+,H+,I+,J+,K-,L+,M-,N+,O+,P+,Q+,R+,S-,T-,U-,V+,W-,X+,Y+,Z1}
program Gridlock;
{$APPTYPE CONSOLE}
{$optimization off}
uses
  SysUtils;

const
  HashSize = 32767;
type
  Block = record
    orient: byte;
    c: array[1..2] of byte;
    len: byte;
  end;
  TState = array[1..18] of byte;

  PItem = ^Item;
  Item = record
    next: PItem;
    state: TState;
  end;

var
  B:Array[1..20] of Block;
  Queue: Array[1..50000] of TState;
  Prev:Array[1..50000] of integer;
  r,w,n,OutNum:integer;
  Hash: array[0..HashSize] of PItem;
  Found:boolean;

function Equal(var A:TState; var B:TState):boolean;
var
  i:integer;
begin
  Equal:=false;
  for i:=1 to n do
    if A[i]<>B[i] then
      Exit;
  Equal:=true;
end;

function GetHashValue(var A:TState):integer;
var
  HashValue: longint;
  i,j:longint;
begin
  HashValue:=0;
  for i:=1 to n do
    begin
      HashValue:=HashValue*6+(A[i]-1);
      HashValue:=HashValue mod HashSize;
    end;
  GetHashValue:=HashValue;
end;

function AddToHash(var A:TState):boolean;
var
  HashValue: longint;
  i,j:longint;
  Cur, NewItem:PItem;
begin
  AddToHash:=false;
  HashValue:=GetHashValue(A);
  Cur:=Hash[HashValue];
  while Cur<>nil do
    begin
      if Equal(Cur^.state, A) then exit;
      Cur:=Cur^.next;
    end;
  New(NewItem);
  NewItem^.next:=Hash[HashValue];
  NewItem^.state:=A;
  Hash[HashValue]:=NewItem;
  AddToHash:=true;
end;

procedure InputData;
var
  i:integer;
  ch:char;
begin
  AssignFile(input,'gridlock.in');
  Reset(input);
  Readln(n);
  for i:=1 to n do
    begin
      read(ch);
      if ch = 'V' then B[i].orient:=1
                  else B[i].orient:=2;
      readln(B[i].c[1], B[i].c[2], B[i].len);
    end;
  AssignFile(output,'gridlock.out');
  Rewrite(output);
end;

procedure OutputData(Cur:integer);
var
  Answer:Array[1..1000,1..2] of integer;
  i,Cnt:integer;
begin
  Cnt:=0;
  while Prev[Cur]<>0 do
    begin
      inc(Cnt);
      for i:=1 to n do
        if Queue[Cur][i]<>Queue[Prev[Cur]][i] then
          begin
            Answer[cnt,1]:=i;
            Answer[cnt,2]:=Queue[Cur][i]-Queue[Prev[Cur]][i];
          end;
      Cur:=Prev[Cur];
    end;
  Writeln(Cnt);
  for i:=Cnt downto 2 do
    Writeln(Answer[i,1],' ',Answer[i,2]);
  CloseFile(output);
  Halt;
end;

procedure AddToQueue(var A:TState);
begin
  if AddToHash(A) then
    begin
      inc(w);
      Queue[w]:=A;
      Prev[w]:=r;
      if Queue[w][1]=5 then
        begin
          Found:=true;
          OutNum:=w;
        end;
    end;
end;

procedure GetFirstState;
var
  i:longint;
  A:TState;
begin
  Fillchar(A,sizeof(A),0);
  for i:=1 to n do
    A[i]:=B[i].C[B[i].orient];
  AddToQueue(A);
end;

procedure AddNewItems;
var
  Table:Array[1..6,1..6] of byte;
  New:TState;
  i,j:longint;
  X:Array[1..2] of byte;

  function CanPut(i,pos:integer):boolean;
  var j:integer;
  begin
    CanPut:=false;
    X[3-B[i].orient]:=B[i].c[3-B[i].orient];
    X[B[i].orient]:=pos;
    for j:=1 to B[i].len do
      if Table[X[1], X[2]] <> 0
        then exit
        else inc(X[B[i].orient]);
    CanPut:=true;
  end;

  procedure Put(i,pos:integer; color:integer);
  var j:integer;      
  begin
    X[3-B[i].orient]:=B[i].c[3-B[i].orient];
    X[B[i].orient]:=pos;
    for j:=1 to B[i].len do
      begin
        Table[X[1], X[2]]:=color;
        inc(X[B[i].orient]);
      end;
  end;

begin
  fillchar(Table,sizeof(Table),0);
  for i:=1 to n do
    Put(i,Queue[r][i],1);
  for i:=1 to n do
    begin
      Put(i,Queue[r][i],0);
      for j:=Queue[r][i]+1 to 7-B[i].len do
        if CanPut(i,j) then
          begin
            New:=Queue[r];
            New[i]:=j;
            AddToQueue(New);
          end
          else break;
      for j:=Queue[r][i]-1 downto 1 do
        if CanPut(i,j) then
          begin
            New:=Queue[r];
            New[i]:=j;
            AddToQueue(New);
          end
          else break;
      Put(i,Queue[r][i],1);
    end;
end;


procedure ProcessData;
var
  i,j:integer;
begin
  Fillchar(Prev,sizeof(Prev),0);
  Found:=false;
  r:=0;w:=0;
  GetFirstState;
  while r<w do
    begin
      inc(r);
      AddNewItems;
      if Found then
        OutputData(OutNum);
    end;
end;

begin
  InputData;
  ProcessData;
end.
